unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Label1: TLabel;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

  do_grad:boolean=false;
  counter:longint=0;

implementation

{$R *.lfm}

{ TForm1 }

procedure createLevelBar(Var AImage:Timage;AValue:Integer;bk:tcolor);
Var      image_height:integer;
         image_width:integer;
         image_half:integer;
begin
  image_width:=AImage.Width;
  image_height:=AImage.Height;
  image_half:=image_height div 2;
  With aimage DO
  Begin
    canvas.Pen.Style:=psClear;;
    Canvas.Brush.Color:=bk;
    Canvas.Brush.style:=bsSolid;
    //paint background
    canvas.Rectangle(0,trunc(image_half*(avalue/100)),image_width+1,image_height-trunc(image_half*(avalue/100)));
    //paint bottom red
    if do_grad then
    begin
      canvas.GradientFill(rect(0,0,image_width,trunc(image_half*(avalue/100))),clyellow,clred,gdVertical);
      canvas.GradientFill(rect(0,image_height-trunc(image_half*(avalue/100)),image_width,image_height),clWhite,clGreen,gdVertical);
    end
    else
    begin
      Canvas.Brush.Color:=clred;
      canvas.Rectangle(0,0,image_width+1,1+trunc(image_half*(avalue/100)));
      Canvas.Brush.Color:=clgreen;
      canvas.Rectangle(0,image_height-trunc(image_half*(avalue/100)),image_width+1,image_height+1);
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  do_grad:=not do_grad;
  if do_grad then button1.caption:='Use Solid Fill' else button1.caption:='Use Gradient Fill';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  form1.DoubleBuffered:=true;
  randomize;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  createLevelBar(image1,random(100),form1.color);
  createLevelBar(image2,random(100),form1.color);
  createLevelBar(image3,random(100),form1.color);
  createLevelBar(image4,random(100),form1.color);
  createLevelBar(image5,random(100),form1.color);
  inc(counter);
  label1.Caption:=inttostr(counter);
  application.ProcessMessages;
end;

end.

